\documentclass[12pt]{report}

\newcommand\lessontitle{Lecture 1 -- Types of Operating Systems}
\newcommand\lessondate{February 4, 2021}

\usepackage[a4paper, landscape, margin=2cm]{geometry}
\usepackage{fontspec}
\usepackage{microtype}
\usepackage{fancyhdr}
\usepackage{sectsty}
\usepackage{graphicx}
\usepackage{flafter}
\usepackage{hyperref}
\usepackage{glossaries}
\usepackage{afterpage}

\setacronymstyle{long-short}

\makeglossaries

\setmainfont{CallunaSans-Regular.otf}[
  BoldFont = CallunaSans-Bold.otf ]
\setsansfont{MuseoSans-500.otf}[
  BoldFont = MuseoSans-900.otf,
  ItalicFont = MuseoSans-500Italic.otf ]

\pagestyle{fancy}
\fancyhf{}
\renewcommand{\headrulewidth}{0.5pt}
\renewcommand{\footrulewidth}{0.5pt}
\lhead{\textsf{Operation of IT Systems -- ENPTIA2401-PRACT}}
\rhead{\textsf{\lessontitle}}
\rfoot{\textsf{Page \thepage}}
\lfoot{\textsf{\lessondate}}

\setcounter{secnumdepth}{0}

\setlength{\parindent}{0pt}

\sectionfont{\clearpage\Huge\sffamily}
\subsectionfont{\sffamily}

\hypersetup{
    colorlinks=true,
    linkcolor=black,
    urlcolor=black,
}
\urlstyle{same}

\newacronym[description={the low-level software that supports a computer's basic functions, such as scheduling tasks and controlling peripherals}, shortplural={OSes}]{os}{OS}{Operating System}
\newacronym[description={is a now discontinued operating system, based on Research Unix.}]{bsd}{BSD}{Berkeley Software Distribution}
\newacronym[description={is software, for which the source code is available}]{oss}{OSS}{Open-Source Software}

\newglossaryentry{kernel}{name={kernel},description={The kernel is a program that constitutes the central core of a computer operating system. It has complete control over everything that occurs in the system.}}
\newglossaryentry{userspace}{name={userspace},description={The term userspace refers to all code that runs outside the operating system's kernel.}}

\begin{document}

\begin{titlepage}
{\Huge \bfseries \textsf{Operation of IT Systems -- ENPTIA2401-PRACT} \par}
\vspace{1cm}
{\Large \bfseries \textsf{\lessontitle} \par}
\vspace{1cm}
{\Large \textsf{\lessondate} \par}
\vfill
{\large \textsf{András Kalmár-Nagy (\href{mailto:andras.kalmar-nagy@t-systems.com}{andras.kalmar-nagy@t-systems.com})}}
\end{titlepage}

\section{Lecturer}
\huge{András Kalmár-Nagy}\\

\normalsize
Solution Engineer @ Deutsche Telekom Systems Solutions Hungary\\

Background in Linux operation for a large national client of DT/T Systems


\section{Syllabus}

\begin{enumerate}
\item Types of Operating Systems
\item Operating system installation
\item Commands and GUI
\item File systems on the user and system admin level
\item Network configuration
\item Exam 1
\item File systems and RAID
\item Remote Desktop and protocols
\item Systems environment
\item Roles , rules on System adminstrator level
\item Hardware management
\item Exam 2
\end{enumerate}

\section{Your backgrounds and goals}

What sort of IT experience do you have?\\

What would you like to get out of this course?\\

\section{Operating System}

An OS is the low-level software that supports a computer's basic functions, such as scheduling tasks and controlling peripherals.\\

Modern OSes are made up of a Kernel, and Userspace programs. The Kernel contains device drivers, a scheduler, memory handling, file systems, and network stacks. Userspace programs communicate with the Kernel using System Calls or syscalls.\\

Modern examples of OSes are Windows, Mac OS X, Linux/GNU, FreeBSD and Android. All of the previously mentioned OSes are descendants of Unix, except for Windows. Unix was originally developed from 1970 and has many versions and was used as the basis of many OSes.\\

One of Unix's derivatives was Berkeley Software Distribution (BSD), which served as the base for both FreeBSD and Darwin, which is the operating system upon which Mac OS, iOS, watchOS, tvOS, and iPadOS are built.\\

Linux was developed by Linus Torvalds in 1991. It is not a complete operating system, just a kernel and device drivers. Userland programs usually come from the GNU project. Although it was written to be compatible with Unix, it is not directly derived from it, to avoid licensing issues. It is open-source.\\

Windows is developed by Microsoft, and was released in 1985. It is a proprietary OS, not based on Unix.\\

Android was developed by Google and is based on Linux, it was released in 2007. Android is also open-source.\\

\subsection{Open-Source Software}

If a software is open-source, it means that the source code, from which the software is compiled into an executable, is available. This means, that the source code can be modified and new versions of the software can be independently developed. It also enables more people to take part in the development of said software, which allows OSS projects to develop quickly.\\

One of the most successful OSS projects is the Linux Kernel itself, with more than 15,600 contributors to the source code of the kernel since 2005. 

\section{Types of Operating Systems}

\subsection{Single-tasking and multi-tasking}
A single-tasking system can only run one program at a time, while a multi-tasking operating system allows more than one program to be running in concurrency. This is achieved by time-sharing, where the available processor time is divided between multiple processes. These processes are each interrupted repeatedly in time slices by a task-scheduling subsystem of the operating system. Multi-tasking may be characterized in pre-emptive and co-operative types. In pre-emptive multitasking, the operating system slices the CPU time and dedicates a slot to each of the programs. Unix-like operating systems, such as Solaris and Linux—as well as non-Unix-like, such as AmigaOS—support pre-emptive multitasking. Cooperative multitasking is achieved by relying on each process to provide time to the other processes in a defined manner. 16-bit versions of Microsoft Windows used cooperative multi-tasking; 32-bit versions of both Windows NT and Win9x used pre-emptive multi-tasking.\\

\subsection{Single- and multi-user}
Single-user operating systems have no facilities to distinguish users, but may allow multiple programs to run in tandem. A multi-user operating system extends the basic concept of multi-tasking with facilities that identify processes and resources, such as disk space, belonging to multiple users, and the system permits multiple users to interact with the system at the same time. Time-sharing operating systems schedule tasks for efficient use of the system and may also include accounting software for cost allocation of processor time, mass storage, printing, and other resources to multiple users.\\

\subsection{Distributed}
A distributed operating system manages a group of distinct, networked computers and makes them appear to be a single computer, as all computations are distributed (divided amongst the constituent computers).\\

\subsection{Templated}
In the distributed and cloud computing context of an OS, templating refers to creating a single virtual machine image as a guest operating system, then saving it as a tool for multiple running virtual machines. The technique is used both in virtualization and cloud computing management, and is common in large server warehouses.

\clearpage

\subsection{Embedded}
Embedded operating systems are designed to be used in embedded computer systems. They are designed to operate on small machines with less autonomy (e.g. PDAs). They are very compact and extremely efficient by design, and are able to operate with a limited amount of resources. Windows CE and Minix 3 are some examples of embedded operating systems.

\subsection{Real-time}
A real-time operating system is an operating system that guarantees to process events or data by a specific moment in time. A real-time operating system may be single- or multi-tasking, but when multitasking, it uses specialized scheduling algorithms so that a deterministic nature of behaviour is achieved. Such an event-driven system switches between tasks based on their priorities or external events, whereas time-sharing operating systems switch tasks based on clock interrupts.

\subsection{Library}
A library operating system is one in which the services that a typical operating system provides, such as networking, are provided in the form of libraries and composed with the application and configuration code to construct a unikernel: a specialized, single address space, machine image that can be deployed to cloud or embedded environments.

\section{Glossary}

\begin{itemize}
	\item \textbf{Operating System} -- An OS is the low-level software that supports a computer’s basic functions, such as scheduling tasks and controlling peripherals.
	\item \textbf{Kernel} -- The kernel is a computer program at the core of a computer's operating system that has complete control over everything in the system.
	\item \textbf{Userspace} -- User space, often concatenated to Userspace, is system memory allocated to running applications.
	\item \textbf{Kernel space} -- The critical code of the kernel is usually loaded into a separate area of memory, which is protected from access by application programs or other, less critical parts of the operating system.
	\item \textbf{BSD} -- Berkeley Software Distribution is a discontinued OS, based on Research Unix. Apple derives its modern operating systems from BSD.
\end{itemize}

\section{Exam questions}

\begin{enumerate}
	\item \textbf{Which modern OSes are related to Unix?} -- Mac OS X, Linux, BSD variants (like FreeBSD) and Android are all related to Unix, Windows is not.
	\item \textbf{Which of these is Open Source (either fully, or in large part): Linux, Mac OS X, Windows, Android?} -- Android and Linux are open-source, Windows and Mac OS X are not.
	\item \textbf{Which is the most popular OS in the world in now? (Feb 2021)} -- Android
	\item \textbf{Which of these OS attributes is an impossible combination? (single-tasking, multi-tasking, single-user, multi-user)} -- A single-tasking, multi user OS. Since single tasking operating systems can only run a single process, they're unable to allow multiple users to use the system at the same time.
\end{enumerate}

\end{document}